"""
Trulioo Python SDK

Package version: 1.0.3
Trulioo OpenAPI version: v1
Generated by OpenAPI Generator version: 5.0.1
"""

import re  # noqa: F401
import sys  # noqa: F401

from trulioo_sdk.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from trulioo_sdk.model.data_fields import DataFields
    globals()['DataFields'] = DataFields


class VerifyRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('call_back_url',): {
            'max_length': 2083,
            'min_length': 0,
        },
        ('configuration_name',): {
            'max_length': 45,
            'min_length': 0,
        },
        ('customer_reference_id',): {
            'max_length': 128,
            'min_length': 0,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'country_code': (str,),  # noqa: E501
            'data_fields': (DataFields,),  # noqa: E501
            'accept_trulioo_terms_and_conditions': (bool,),  # noqa: E501
            'demo': (bool,),  # noqa: E501
            'call_back_url': (str,),  # noqa: E501
            'timeout': (int,),  # noqa: E501
            'cleansed_address': (bool,),  # noqa: E501
            'configuration_name': (str,),  # noqa: E501
            'consent_for_data_sources': ([str],),  # noqa: E501
            'customer_reference_id': (str,),  # noqa: E501
            'verbose_mode': (bool,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'country_code': 'CountryCode',  # noqa: E501
        'data_fields': 'DataFields',  # noqa: E501
        'accept_trulioo_terms_and_conditions': 'AcceptTruliooTermsAndConditions',  # noqa: E501
        'demo': 'Demo',  # noqa: E501
        'call_back_url': 'CallBackUrl',  # noqa: E501
        'timeout': 'Timeout',  # noqa: E501
        'cleansed_address': 'CleansedAddress',  # noqa: E501
        'configuration_name': 'ConfigurationName',  # noqa: E501
        'consent_for_data_sources': 'ConsentForDataSources',  # noqa: E501
        'customer_reference_id': 'CustomerReferenceID',  # noqa: E501
        'verbose_mode': 'VerboseMode',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, country_code, data_fields, *args, **kwargs):  # noqa: E501
        """VerifyRequest - a model defined in OpenAPI

        Args:
            country_code (str): The country code for which the verification needs to be performed.
            data_fields (DataFields):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accept_trulioo_terms_and_conditions (bool): Indicate that Trulioo terms and conditions are accepted. [optional]  # noqa: E501
            demo (bool): This field is not used anymore.  If provided it must match the setting on your account or you will get an error.. [optional]  # noqa: E501
            call_back_url (str): [optional]  # noqa: E501
            timeout (int): [optional]  # noqa: E501
            cleansed_address (bool): Set to true if you want to receive address cleanse information,  This will only change the response if you have address cleansing enabled for the country you are querying for.. [optional]  # noqa: E501
            configuration_name (str): Indicate the configuration used for the verification. Currently only  'Identity Verification' is supported.. [optional]  # noqa: E501
            consent_for_data_sources ([str]): Some datasources required your customer provide consent to access them.  Set that the customer has provided consent for each  datasource that requires one.  If consent is not provided the datasource will not be queried.. [optional]  # noqa: E501
            customer_reference_id (str): Customer Reference Id. [optional]  # noqa: E501
            verbose_mode (bool): Verbose Mode Output Flag.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.country_code = country_code
        self.data_fields = data_fields
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
